# == Class: flufflepuffgasp
#
# Full description of class flufflepuffgasp here.
#
# === Parameters
#
# Document parameters here.
#
# [*sample_parameter*]
#   Explanation of what this parameter affects and what it defaults to.
#   e.g. "Specify one or more upstream ntp servers as an array."
#
# === Variables
#
# Here you should define a list of variables that this module would require.
#
# [*sample_variable*]
#   Explanation of how this variable affects the funtion of this class and if
#   it has a default. e.g. "The parameter enc_ntp_servers must be set by the
#   External Node Classifier as a comma separated list of hostnames." (Note,
#   global variables should be avoided in favor of class parameters as
#   of Puppet 2.6.)
#
# === Examples
#
#  class { 'flufflepuffgasp':
#    servers => [ 'pool.ntp.org', 'ntp.local.company.com' ],
#  }
#
# === Authors
#
# Author Name <author@domain.com>
#
# === Copyright
#
# Copyright 2016 Your name here, unless otherwise noted.
#
class flufflepuffgasp (
  $service_ensure     = $flufflepuffgasp::params::service_ensure,
  $service_manage     = $flufflepuffgasp::params::service_manage,
  $service_name       = $flufflepuffgasp::params::service_name,
  $package_ensure     = $flufflepuffgasp::params::package_ensure,
  $package_name       = $flufflepuffgasp::params::package_name,
  $package_provider   = $flufflepuffgasp::params::package_provider,
  $version            = $flufflepuffgasp::params::version,
  $repo_key,
  #port the web service should listen on
  $server_port,
  #encyrption key and initialization vector for cookies in future
  #$encryption_key,
  #$encryption_iv,
  #github key for oauth
  $manage_ssl_proxy   = $flufflepuffgasp::params::manage_ssl_proxy,
  $domain             = $flufflepuffgasp::params::domain,
  $repos_ensure       = $flufflepuffgasp::params::repos_ensure,
  #should the service be managed
) inherits flufflepuffgasp::params {


  case $::osfamily {

    'Debian': {
      if ! defined(Class['::ppa']) {
        class { '::ppa' :
         repo_key  => $repo_key,
         allow_unsigned => true
        }
      }
      $package_require = Class['apt::update']
    }
    default: {
      $package_require = undef
    }
  }

	  include flufflepuffgasp::install
    include flufflepuffgasp::config
    include flufflepuffgasp::service

}
