class flufflepuffgasp::service(
  $service_ensure = $flufflepuffgasp::service_ensure,
  $service_manage = $flufflepuffgasp::service_manage,
  $service_name   = $flufflepuffgasp::service_name,
  $manage_ssl_proxy = $flufflepuffgasp::manage_ssl_proxy,
  $server_port    = $flufflepuffgasp::server_port,
  $raw_domain     = $flufflepuffgasp::raw_domain,
) inherits flufflepuffgasp {

  require jdk_oracle
  require nginx
  if ($manage_ssl_proxy) {
    nginx::resource::vhost { 'flufflepuffgasp.com':
      proxy => "http://127.0.0.1:${server_port}",
      rewrite_to_https => true,
      index_files => [],
      listen_port => 80,
      ssl_cert => "/etc/letsencrypt/live/${raw_domain}/fullchain.pem",
      ssl_key => "/etc/letsencrypt/live/${raw_domain}/privkey.pem",
      ssl => true,
      ssl_port => 443
    }
  }
  validate_re($service_ensure, '^(running|stopped)$')
  validate_bool($service_manage)

  if ($service_manage) {
    if $service_ensure == 'running' {
      $ensure_real = 'running'
      $enable_real = true
    } else {
      $ensure_real = 'stopped'
      $enable_real = false
    }

    service { 'flufflepuffgasp':
      ensure     => $ensure_real,
      enable     => $enable_real,
      hasstatus  => true,
      hasrestart => true,
      name       => $service_name,
	    require    => Package['flufflepuffgasp']
    }
  }

}